%define basic variables
clear;
clc;
Rho=1030;
CalibrationDepth=11;
g=9.81;
AverageVolt=269.9;
Avolt=Rho*g*CalibrationDepth/AverageVolt;
load rawdata.txt;
%transformation from Volts to pressure using calibration constants Avolt
%and Bvolt
%Avolt has dimension Pa/V, Bvolt has dimension Pa
Bvolt=0;
P=Avolt*rawdata+Bvolt;  
%interval is the sample frequency interval of the sensor
interval=.25;
n=numel(rawdata); %count number of samples
tottime=n*interval; %calculate total duration of observation in sec
ttime=(interval:interval:tottime); %create array with time
time=ttime.'; %change orientation of matrix
% calculate regression coefficients to compensate for change in waterlevel
% during the observations
%plot(time,P);
B = [ones(length(time),1) time] \ P;
Slope=B(2);
Intercept=B(1);
Pwave=P-Intercept'-time*Slope;
plot(time,Pwave);
xlabel('time');
ylabel('pressure (Pa)');
Pstatic=P-Pwave;
Depth=Pstatic/Rho/g;
%plot(time,Depth);
counter=0;
Pmin=0;
Pmax=0;
period=0;
for k=1:n-1
    if(Pwave(k+1)*Pwave(k)<0 && Pwave(k+1)<0)  %new wave starts at k+1
        counter=counter+1;
        T(counter)=period;
        L0=g/2/pi*period*period;
        if (Depth(k)/L0 < 0.36) 
            L=sqrt(g*Depth(k))*(1-Depth(k)/L0)*period;
        else
            L=L0;
        end;
        H(counter)=(Pmax-Pmin)/Rho/g*cosh(2*pi/L/Depth(k));
        Pmax=0;
        Pmin=0;
        period=0;
    end;
    if(Pwave(k)>Pmax)  Pmax=Pwave(k);
    end;
    if (Pwave(k)<Pmin) Pmin=Pwave(k);
    end;
    period=period+interval;
end;
%counter = number of waves found
Hsorted=sort(H);
kk=0;
for k=1:counter
    if  Hsorted(k)>0.20
        kk=kk+1;
        Hsorted2(kk)=Hsorted(k);
        counter=kk;
    end;
end;
Tsorted=sort(T);
Tmean= mean (Tsorted)

       for k=1 : counter    
prob(k)= (counter-k+1)/counter;
end;
probplot('rayleigh',Hsorted2);
xlabel('wave height (m)');
Hmean=mean(Hsorted2);
Hrms=rms(Hsorted2);
sum=0;
for k=2*counter/3:counter
    sum=sum+Hsorted2(counter);
end
Hs=sum/(counter/3);

